# -*- coding: utf-8 -*-
"""
/***************************************************************************
 OsmHiking
                                 A QGIS plugin
 This plugin helps to prepare maps for hiking.osm.be
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                              -------------------
        begin                : 2021-07-12
        git sha              : $Format:%H$
        copyright            : (C) 2021 by Champs-Libres Coopérative
        email                : julien.minet@champs-libres.coop
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""
from qgis.PyQt.QtCore import QSettings, QTranslator, QCoreApplication, Qt
from qgis.PyQt.QtGui import QIcon
from qgis.PyQt.QtWidgets import QAction
from qgis.core import QgsVectorFileWriter, QgsCoordinateReferenceSystem, QgsProject, QgsCoordinateTransform, QgsVectorLayer

# Initialize Qt resources from file resources.py
from .resources import *
# Import the code for the dialog
from .osm_hiking_dialog import OsmHikingDialog
import os.path
import os

class OsmHiking:
    """QGIS Plugin Implementation."""

    def __init__(self, iface):
        """Constructor.

        :param iface: An interface instance that will be passed to this class
            which provides the hook by which you can manipulate the QGIS
            application at run time.
        :type iface: QgsInterface
        """

        # Save reference to the QGIS interface
        self.iface = iface
        # initialize plugin directory
        self.plugin_dir = os.path.dirname(__file__)
        # initialize locale
        locale = QSettings().value('locale/userLocale')[0:2]
        locale_path = os.path.join(
            self.plugin_dir,
            'i18n',
            'OsmHiking_{}.qm'.format(locale))

        if os.path.exists(locale_path):
            self.translator = QTranslator()
            self.translator.load(locale_path)
            QCoreApplication.installTranslator(self.translator)

        # Declare instance attributes
        self.actions = []
        self.menu = self.tr(u'&hiking.osm.be')

        # Check if plugin was started the first time in current QGIS session
        # Must be set in initGui() to survive plugin reloads
        self.first_start = None

    # noinspection PyMethodMayBeStatic
    def tr(self, message):
        """Get the translation for a string using Qt translation API.

        We implement this ourselves since we do not inherit QObject.

        :param message: String for translation.
        :type message: str, QString

        :returns: Translated version of message.
        :rtype: QString
        """
        # noinspection PyTypeChecker,PyArgumentList,PyCallByClass
        return QCoreApplication.translate('OsmHiking', message)


    def add_action(
        self,
        icon_path,
        text,
        callback,
        enabled_flag=True,
        add_to_menu=True,
        add_to_toolbar=True,
        status_tip=None,
        whats_this=None,
        parent=None):
        """Add a toolbar icon to the toolbar.

        :param icon_path: Path to the icon for this action. Can be a resource
            path (e.g. ':/plugins/foo/bar.png') or a normal file system path.
        :type icon_path: str

        :param text: Text that should be shown in menu items for this action.
        :type text: str

        :param callback: Function to be called when the action is triggered.
        :type callback: function

        :param enabled_flag: A flag indicating if the action should be enabled
            by default. Defaults to True.
        :type enabled_flag: bool

        :param add_to_menu: Flag indicating whether the action should also
            be added to the menu. Defaults to True.
        :type add_to_menu: bool

        :param add_to_toolbar: Flag indicating whether the action should also
            be added to the toolbar. Defaults to True.
        :type add_to_toolbar: bool

        :param status_tip: Optional text to show in a popup when mouse pointer
            hovers over the action.
        :type status_tip: str

        :param parent: Parent widget for the new action. Defaults None.
        :type parent: QWidget

        :param whats_this: Optional text to show in the status bar when the
            mouse pointer hovers over the action.

        :returns: The action that was created. Note that the action is also
            added to self.actions list.
        :rtype: QAction
        """

        icon = QIcon(icon_path)
        action = QAction(icon, text, parent)
        action.triggered.connect(callback)
        action.setEnabled(enabled_flag)

        if status_tip is not None:
            action.setStatusTip(status_tip)

        if whats_this is not None:
            action.setWhatsThis(whats_this)

        if add_to_toolbar:
            # Adds plugin icon to Plugins toolbar
            self.iface.addToolBarIcon(action)

        if add_to_menu:
            self.iface.addPluginToMenu(
                self.menu,
                action)

        self.actions.append(action)

        return action

    def initGui(self):
        """Create the menu entries and toolbar icons inside the QGIS GUI."""

        icon_path = ':/plugins/osm_hiking/icon.png'
        self.add_action(
            icon_path,
            text=self.tr(u'hiking.osm.be'),
            callback=self.run,
            parent=self.iface.mainWindow())

        # will be set False in run()
        self.first_start = True


    def unload(self):
        """Removes the plugin menu item and icon from QGIS GUI."""
        for action in self.actions:
            self.iface.removePluginMenu(
                self.tr(u'&hiking.osm.be'),
                action)
            self.iface.removeToolBarIcon(action)


    def zoom(self, item):
        layer = self.iface.activeLayer()
        layer.selectByExpression(f'\"place\" = \'{item.text()}\'')
        self.iface.actionZoomToSelected().trigger()

    def export_valid_geojson(self):

        # TODO 1: run the delete hole tool

        layer = self.iface.activeLayer() #TODO 2: get the frame layer

        (current_dir, layer_name) = os.path.split(layer.dataProvider().dataSourceUri())
        export_name = f"{current_dir}/{layer_name.split('.')[0]}.geojson"

        wgs84 = QgsCoordinateReferenceSystem('EPSG:4326')
        web_mercator = QgsCoordinateReferenceSystem('EPSG:3857')

        transform_context = QgsProject.instance().transformContext()
        
        if isinstance(layer, QgsVectorLayer):
            save_options = QgsVectorFileWriter.SaveVectorOptions()
            save_options.driverName = "geojson"
            save_options.fileEncoding = "UTF-8"
            save_options.layerOptions = ['id_field=fid']
            save_options.ct = QgsCoordinateTransform(web_mercator, wgs84, transform_context)

            error = QgsVectorFileWriter.writeAsVectorFormatV2(
                layer,
                export_name,
                transform_context,
                save_options
            )
            if error[0] == QgsVectorFileWriter.NoError:
                self.iface.messageBar().pushMessage("Le fichier geojson a bien été enregistré sous: ", export_name)

            else:
                self.iface.messageBar().pushWarning("Erreur lors de l'export du geojson", error)
        else:
            self.iface.messageBar().pushWarning("La couche sélectionnée ne peut pas être exportée en geojson", "")

    def run(self):
        """Run method that performs all the real work"""

        print('RUN')
        
        # Create the dialog with elements (after translation) and keep reference
        # Only create GUI ONCE in callback, so that it will only load when the plugin is started
        if self.first_start == True:
            self.first_start = False
            self.dlg = OsmHikingDialog()
            self.dlg.listWidget.setSortingEnabled(True)
            self.dlg.listWidget.itemClicked.connect(self.zoom)
            layer = self.iface.activeLayer()
            if isinstance(layer, QgsVectorLayer):
                for f in layer.getFeatures():
                    self.dlg.listWidget.addItem(f["place"])
        
        # self.dlg.listWidget.sortItems(Qt.DescendingOrder) # in case we want a descending order


        # register the function to the button
        self.dlg.pushButton.clicked.connect(self.export_valid_geojson)

        # show the dialog
        self.dlg.show()
        # Run the dialog event loop
        result = self.dlg.exec_()
        # See if OK was pressed
        if result:
            # Do something useful here - delete the line containing pass and
            # substitute with your code.
            pass
